
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Study_group_messagesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const study_group_messages = await db.study_group_messages.create(
            {
                id: data.id || undefined,
        
        type: data.type
        ||
        null
            ,
            
        content: data.content
        ||
        null
            ,
            
        file_name: data.file_name
        ||
        null
            ,
            
        file_url: data.file_url
        ||
        null
            ,
            
        sent_at: data.sent_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await study_group_messages.setStudy_group( data.study_group || null, {
            transaction,
        });
        
        await study_group_messages.setSender( data.sender || null, {
            transaction,
        });
        

        

        

        return study_group_messages;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const study_group_messagesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                type: item.type
            ||
            null
            ,
            
                content: item.content
            ||
            null
            ,
            
                file_name: item.file_name
            ||
            null
            ,
            
                file_url: item.file_url
            ||
            null
            ,
            
                sent_at: item.sent_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const study_group_messages = await db.study_group_messages.bulkCreate(study_group_messagesData, { transaction });

        // For each item created, replace relation files
        

        return study_group_messages;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const study_group_messages = await db.study_group_messages.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.type !== undefined) updatePayload.type = data.type;
        
        
        if (data.content !== undefined) updatePayload.content = data.content;
        
        
        if (data.file_name !== undefined) updatePayload.file_name = data.file_name;
        
        
        if (data.file_url !== undefined) updatePayload.file_url = data.file_url;
        
        
        if (data.sent_at !== undefined) updatePayload.sent_at = data.sent_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await study_group_messages.update(updatePayload, {transaction});

        
        
        if (data.study_group !== undefined) {
            await study_group_messages.setStudy_group(
              
              data.study_group,
              
              { transaction }
            );
        }
        
        if (data.sender !== undefined) {
            await study_group_messages.setSender(
              
              data.sender,
              
              { transaction }
            );
        }
        

        
        

        

        return study_group_messages;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const study_group_messages = await db.study_group_messages.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of study_group_messages) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of study_group_messages) {
                await record.destroy({transaction});
            }
        });


        return study_group_messages;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const study_group_messages = await db.study_group_messages.findByPk(id, options);

        await study_group_messages.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await study_group_messages.destroy({
            transaction
        });

        return study_group_messages;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const study_group_messages = await db.study_group_messages.findOne(
            { where },
            { transaction },
        );

        if (!study_group_messages) {
            return study_group_messages;
        }

        const output = study_group_messages.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.study_group = await study_group_messages.getStudy_group({
            transaction
        });
        
        
        output.sender = await study_group_messages.getSender({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.study_groups,
        as: 'study_group',
        
        where: filter.study_group ? {
          [Op.or]: [
            { id: { [Op.in]: filter.study_group.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.study_group.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'sender',
        
        where: filter.sender ? {
          [Op.or]: [
            { id: { [Op.in]: filter.sender.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.sender.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.content) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'study_group_messages',
                        'content',
                        filter.content,
                    ),
                };
            }
            
            if (filter.file_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'study_group_messages',
                        'file_name',
                        filter.file_name,
                    ),
                };
            }
            
            if (filter.file_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'study_group_messages',
                        'file_url',
                        filter.file_url,
                    ),
                };
            }
            

            
            

            
            if (filter.sent_atRange) {
                const [start, end] = filter.sent_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.type) {
                where = {
                    ...where,
                type: filter.type,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.study_group_messages.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'study_group_messages',
                        'content',
                        query,
                    ),
                ],
            };
        }

        const records = await db.study_group_messages.findAll({
            attributes: [ 'id', 'content' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['content', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.content,
        }));
    }

    
};

